;;; This file is part of nanolisp, a very small Lisp system.

;;; Copyright (C) 2007  Luca Saiu

;;; This program is free software: you can redistribute it and/or modify
;;; it under the terms of the GNU General Public License as published by
;;; the Free Software Foundation, either version 3 of the License, or
;;; (at your option) any later version.

;;; This program is distributed in the hope that it will be useful,
;;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;; GNU General Public License for more details.

;;; You should have received a copy of the GNU General Public License
;;; along with this program.  If not, see <http://www.gnu.org/licenses/>.


;;; This uses a slightly less stupid algorithm than primes.scm

(define for-all?
  (lambda (predicate list)
    (if (null? list)
        #t
        (if (predicate (car list))
            (for-all? predicate (cdr list))
            #f))))

(define not
  (lambda (b)
    (if b #f #t)))

(define prime-with-respect-to?
  (lambda (n smaller-primes)
    (for-all? (lambda (i)
                (not (= (remainder n i) 0)))
              smaller-primes)))

(define print-all-primes
  (lambda ()
    (print-primes-starting-from 2 '())))

(define print-primes-starting-from
  (lambda (n smaller-primes)
    (if (prime-with-respect-to? n smaller-primes)
        (begin
          (display n)
          (newline)
          (print-primes-starting-from (+ n 1) (cons n smaller-primes)))
        (print-primes-starting-from (+ n 1) smaller-primes))))

(print-all-primes)
